Public Class DataGridBoolColumnEx
    Inherits DataGridBoolColumn
    Implements IDataGridColumnConstraintEx


    Private col As Color
    Private b As SolidBrush

    Public Sub New()
        Me.New(Color.Violet)
    End Sub

    Public Sub New(ByVal c As Color)
        MyBase.New()
        Me.AllowNull = False
        col = c
        b = New SolidBrush(col)
    End Sub

    Public Overloads Sub Dispose()
        MyBase.Dispose()
        b.Dispose()
    End Sub

    Protected Overloads Overrides Sub Paint( _
            ByVal g As Graphics, _
            ByVal bounds As Rectangle, _
            ByVal source As CurrencyManager, _
            ByVal rowNum As Integer, _
            ByVal backBrush As Brush, _
            ByVal foreBrush As Brush, _
            ByVal alignToRight As Boolean)
        If rowNum < 0 Then
            MsgBox("hdr")
        End If
        If Me.GetColumnValueAtRow(source, rowNum).Equals(True) Then
            MyBase.Paint(g, bounds, source, rowNum, b, foreBrush, alignToRight)
        Else
            MyBase.Paint(g, bounds, source, rowNum, backBrush, foreBrush, alignToRight)
        End If
    End Sub

    Public Sub CellPaint( _
            ByVal g As Graphics, _
            ByVal bounds As Rectangle, _
            ByVal source As CurrencyManager, _
            ByVal rowNum As Integer, _
            ByVal backBrush As Brush, _
            ByVal foreBrush As Brush, _
            ByVal alignToRight As Boolean _
    ) Implements IDataGridColumnConstraintEx.CellPaint
        Me.Paint(g, bounds, source, rowNum, backBrush, foreBrush, alignToRight)
    End Sub

End Class

Public Class DataGridTextBoxColumnEx
    Inherits DataGridTextBoxColumn
    Implements IDataGridColumnConstraintEx

    'Private col As Color
    'Private b As SolidBrush

    'Public Sub New()
    '    Me.New(Color.DarkViolet)
    'End Sub

    'Public Sub New(ByVal c As Color)
    '    MyBase.New()
    '    col = c
    '    b = New SolidBrush(col)
    'End Sub

    'Public Overloads Sub Dispose()
    '    MyBase.Dispose()
    '    b.Dispose()
    'End Sub

    Public Sub CellPaint( _
            ByVal g As Graphics, _
            ByVal bounds As Rectangle, _
            ByVal source As CurrencyManager, _
            ByVal rowNum As Integer, _
            ByVal backBrush As Brush, _
            ByVal foreBrush As Brush, _
            ByVal alignToRight As Boolean _
    ) Implements IDataGridColumnConstraintEx.CellPaint
        Me.Paint(g, bounds, source, rowNum, backBrush, foreBrush, alignToRight)
    End Sub

    'Protected Overloads Overrides Sub Paint( _
    '        ByVal g As Graphics, _
    '        ByVal bounds As Rectangle, _
    '        ByVal source As CurrencyManager, _
    '        ByVal rowNum As Integer, _
    '        ByVal backBrush As Brush, _
    '        ByVal foreBrush As Brush, _
    '        ByVal alignToRight As Boolean)
    '    If Me.GetColumnValueAtRow(source, rowNum).Equals(True) Then
    '        MyBase.Paint(g, bounds, source, rowNum, backBrush, b, alignToRight)
    '    Else
    '        MyBase.Paint(g, bounds, source, rowNum, backBrush, foreBrush, alignToRight)
    '    End If
    'End Sub

End Class

Public Interface IDataGridColumnConstraintEx
    Sub CellPaint( _
            ByVal g As Graphics, _
            ByVal bounds As Rectangle, _
            ByVal source As CurrencyManager, _
            ByVal rowNum As Integer, _
            ByVal backBrush As Brush, _
            ByVal foreBrush As Brush, _
            ByVal alignToRight As Boolean _
    )
End Interface
