Public Class DataGridPushPinColumn
    Inherits DataGridBoolColumn
    Implements IDataGridColumnConstraintEx

    Friend WithEvents objImageList As System.Windows.Forms.ImageList
    Private components As System.ComponentModel.IContainer

    Private privCtl As PushPinControl
    Private SavedY As Integer
    Private SavedX As Integer

    Public Sub New()
        InitializeComponent()
    End Sub

    Public Overloads Sub Dispose()
        MyBase.Dispose()
    End Sub

    Protected Overrides Function GetMinimumHeight() As Integer
        Return 16
    End Function

    Protected Overrides Function GetPreferredHeight(ByVal g As Graphics, ByVal value As Object) As Integer
        Return 16
    End Function

    Protected Overrides Function GetPreferredSize(ByVal g As Graphics, ByVal Value As Object) As Size
        Dim PicSize As Size = New Size(16, 16)
        Return PicSize
    End Function

    Protected Overloads Overrides Sub Paint(ByVal g As Graphics, ByVal Bounds As Rectangle, ByVal Source As CurrencyManager, ByVal RowNum As Integer)
        Dim BackBrush As SolidBrush = New SolidBrush(Color.White)
        Dim obj As Object
        Dim v As Boolean
        obj = Me.GetColumnValueAtRow(Source, RowNum)
        If TypeOf obj Is DBNull Then
            v = False
        Else
            Try
                v = CBool(obj)
            Catch
            End Try
        End If
        Dim ImagePic As Bitmap
        If v = False Then
            ImagePic = CType(objImageList.Images(0), Bitmap)
        Else
            ImagePic = CType(objImageList.Images(1), Bitmap)
        End If
        g.FillRectangle(BackBrush, Bounds.X, Bounds.Y, Bounds.Width, Bounds.Height)
        g.DrawImage(CType(ImagePic, Image), Bounds.X + ((Bounds.Width - ImagePic.Width) \ 2), Bounds.Y, ImagePic.Width, ImagePic.Height)
        If IsEditing = RowNum Then
            m.WaitOne()
            If privCtl Is Nothing Then
                If Bounds.X > Me.DataGridTableStyle.DataGrid.RowHeaderWidth Then
                    privCtl = New PushPinControl(v, Me, Source, RowNum)
                    privCtl.Location = New System.Drawing.Point(Bounds.X, Bounds.Y)
                    SavedY = Bounds.Y
                    SavedX = Bounds.X
                    privCtl.Size = New System.Drawing.Size(Bounds.Width, Bounds.Height)
                    Me.DataGridTableStyle.DataGrid.Controls.Add(privCtl)
                    AddHandler Me.DataGridTableStyle.DataGrid.CurrentCellChanged, AddressOf HidePushPinControl
                    AddHandler Me.DataGridTableStyle.DataGrid.Scroll, AddressOf HidePushPinControl
                Else
                    g.FillRectangle(BackBrush, Bounds.X, Bounds.Y, Bounds.Width, Bounds.Height)
                    g.DrawImage(CType(ImagePic, Image), Bounds.X + ((Bounds.Width - ImagePic.Width) \ 2), Bounds.Y, ImagePic.Width, ImagePic.Height)
                End If
                m.ReleaseMutex()
            End If
        End If
    End Sub

    Protected Overloads Overrides Sub Paint(ByVal g As Graphics, ByVal Bounds As Rectangle, ByVal Source As CurrencyManager, ByVal RowNum As Integer, ByVal AlignToRight As Boolean)
        Dim BackBrush As SolidBrush = New SolidBrush(Color.White)
        Dim obj As Object
        Dim v As Boolean
        obj = Me.GetColumnValueAtRow(Source, RowNum)
        If TypeOf obj Is DBNull Then
            v = False
        Else
            Try
                v = CBool(obj)
            Catch
            End Try
        End If
        Dim ImagePic As Bitmap
        If v = False Then
            ImagePic = CType(objImageList.Images(0), Bitmap)
        Else
            ImagePic = CType(objImageList.Images(1), Bitmap)
        End If
        g.FillRectangle(BackBrush, Bounds.X, Bounds.Y, Bounds.Width, Bounds.Height)
        g.DrawImage(CType(ImagePic, Image), Bounds.X + ((Bounds.Width - ImagePic.Width) \ 2), Bounds.Y, ImagePic.Width, ImagePic.Height)
        If IsEditing = RowNum Then
            m.WaitOne()
            If privCtl Is Nothing Then
                If Bounds.X > Me.DataGridTableStyle.DataGrid.RowHeaderWidth Then
                    privCtl = New PushPinControl(v, Me, Source, RowNum)
                    privCtl.Location = New System.Drawing.Point(Bounds.X, Bounds.Y)
                    SavedY = Bounds.Y
                    SavedX = Bounds.X
                    privCtl.Size = New System.Drawing.Size(Bounds.Width, Bounds.Height)
                    Me.DataGridTableStyle.DataGrid.Controls.Add(privCtl)
                    AddHandler Me.DataGridTableStyle.DataGrid.CurrentCellChanged, AddressOf HidePushPinControl
                    AddHandler Me.DataGridTableStyle.DataGrid.Scroll, AddressOf HidePushPinControl
                Else
                    g.FillRectangle(BackBrush, Bounds.X, Bounds.Y, Bounds.Width, Bounds.Height)
                    g.DrawImage(CType(ImagePic, Image), Bounds.X + ((Bounds.Width - ImagePic.Width) \ 2), Bounds.Y, ImagePic.Width, ImagePic.Height)
                End If
                m.ReleaseMutex()
            End If
        End If
    End Sub

    Protected Overloads Overrides Sub Paint(ByVal g As Graphics, ByVal Bounds As Rectangle, ByVal Source As CurrencyManager, ByVal RowNum As Integer, ByVal BackBrush As Brush, ByVal ForeBrush As Brush, ByVal AlignToRight As Boolean)
        Dim obj As Object
        Dim v As Boolean
        obj = Me.GetColumnValueAtRow(Source, RowNum)
        If TypeOf obj Is DBNull Then
            v = False
        Else
            Try
                v = CBool(obj)
            Catch
            End Try
        End If
        Dim ImagePic As Bitmap
        If v = False Then
            ImagePic = CType(objImageList.Images(0), Bitmap)
        Else
            ImagePic = CType(objImageList.Images(1), Bitmap)
        End If
        g.FillRectangle(BackBrush, Bounds.X, Bounds.Y, Bounds.Width, Bounds.Height)
        g.DrawImage(CType(ImagePic, Image), Bounds.X + ((Bounds.Width - ImagePic.Width) \ 2), Bounds.Y, ImagePic.Width, ImagePic.Height)
        If IsEditing = RowNum Then
            m.WaitOne()
            If privCtl Is Nothing Then
                If Bounds.X > Me.DataGridTableStyle.DataGrid.RowHeaderWidth Then
                    privCtl = New PushPinControl(v, Me, Source, RowNum)
                    privCtl.Location = New System.Drawing.Point(Bounds.X, Bounds.Y)
                    SavedY = Bounds.Y
                    SavedX = Bounds.X
                    privCtl.Size = New System.Drawing.Size(Bounds.Width, Bounds.Height)
                    Me.DataGridTableStyle.DataGrid.Controls.Add(privCtl)
                    AddHandler Me.DataGridTableStyle.DataGrid.CurrentCellChanged, AddressOf HidePushPinControl
                    AddHandler Me.DataGridTableStyle.DataGrid.Scroll, AddressOf HidePushPinControl
                Else
                    g.FillRectangle(BackBrush, Bounds.X, Bounds.Y, Bounds.Width, Bounds.Height)
                    g.DrawImage(CType(ImagePic, Image), Bounds.X + ((Bounds.Width - ImagePic.Width) \ 2), Bounds.Y, ImagePic.Width, ImagePic.Height)
                End If
                m.ReleaseMutex()
            End If
        End If
    End Sub

    Private m As New System.Threading.Mutex()

    Private Sub HidePushPinControl(ByVal sender As Object, ByVal e As System.EventArgs)
        RemoveHandler Me.DataGridTableStyle.DataGrid.CurrentCellChanged, AddressOf HidePushPinControl
        RemoveHandler Me.DataGridTableStyle.DataGrid.Scroll, AddressOf HidePushPinControl
        IsEditing = -1
        SavedY = -1
        SavedX = -1
        m.WaitOne()
        If Not privCtl Is Nothing Then
            Try
                Me.DataGridTableStyle.DataGrid.Controls.Remove(privCtl)
                privCtl.Dispose()
                privCtl = Nothing
            Catch ex As Exception
            End Try
        End If
        m.ReleaseMutex()
        Me.DataGridTableStyle.DataGrid.Invalidate()
    End Sub

    Public Sub CellPaint( _
            ByVal g As Graphics, _
            ByVal bounds As Rectangle, _
            ByVal source As CurrencyManager, _
            ByVal rowNum As Integer, _
            ByVal backBrush As Brush, _
            ByVal foreBrush As Brush, _
            ByVal alignToRight As Boolean _
    ) Implements IDataGridColumnConstraintEx.CellPaint
        Me.Paint(g, bounds, source, rowNum, backBrush, foreBrush, alignToRight)
    End Sub

    Private IsEditing As Integer

    Protected Overrides Sub Abort(ByVal RowNum As Integer)
        m.WaitOne()
        If Not privCtl Is Nothing Then
            Me.DataGridTableStyle.DataGrid.Controls.Remove(privCtl)
            privCtl.Dispose()
            privCtl = Nothing
        End If
        m.ReleaseMutex()
        IsEditing = -1
        SavedY = -1
        SavedX = -1
    End Sub

    Protected Overrides Function Commit(ByVal DataSource As CurrencyManager, ByVal RowNum As Integer) As Boolean
        Return True
    End Function

    Public Function CommitEdit(ByVal DataSource As CurrencyManager, ByVal RowNum As Integer, ByVal Value As Boolean) As Boolean
        SetValue(DataSource, RowNum, Value)
        SavedY = -1
        SavedX = -1
        IsEditing = -1
        m.WaitOne()
        If Not privCtl Is Nothing Then
            Me.DataGridTableStyle.DataGrid.Controls.Remove(privCtl)
            privCtl.Dispose()
            privCtl = Nothing
        End If
        m.ReleaseMutex()
    End Function

    Public Function SetValue(ByVal DataSource As CurrencyManager, ByVal RowNum As Integer, ByVal Value As Boolean) As Boolean
        Try
            Me.SetColumnValueAtRow(DataSource, RowNum, Value)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Protected Overloads Overrides Sub Edit(ByVal Source As CurrencyManager, ByVal Rownum As Integer, ByVal Bounds As Rectangle, ByVal IsReadOnly As Boolean, ByVal InstantText As String, ByVal CellIsVisible As Boolean)
        If IsEditing <> Rownum And IsEditing >= 0 Then
            Try
                CommitEdit(Source, IsEditing, privCtl.Value)
                Me.Commit(Source, IsEditing)
            Catch ex As Exception
            End Try
        End If
        IsEditing = Rownum
        Me.DataGridTableStyle.DataGrid.Invalidate()
    End Sub

    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(DataGridPushPinColumn))
        Me.objImageList = New System.Windows.Forms.ImageList(Me.components)
        '
        'objImageList
        '
        Me.objImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit
        Me.objImageList.ImageSize = New System.Drawing.Size(16, 16)
        Me.objImageList.ImageStream = CType(resources.GetObject("objImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.objImageList.TransparentColor = System.Drawing.Color.Transparent

    End Sub
End Class
