Imports System.Web.Mail

Public Class DataSetExport
    Public Shared Sub Export(ByVal ds As DataSet)
        Dim objSaveFileDialog As New System.Windows.Forms.SaveFileDialog()
        objSaveFileDialog.Filter = "File Xml (*.xml)|*.xml|File Html (*.htm)|*.htm|Tutti i File (*.*)|*.*"
        objSaveFileDialog.Title = "Esportazione dei Dati"
        If objSaveFileDialog.ShowDialog() = DialogResult.OK Then
            Try
                If Right(objSaveFileDialog.FileName, 3).ToLower = "xml" Then
                    ExportXml(objSaveFileDialog.FileName, ds)
                Else
                    ExportHtml(objSaveFileDialog.FileName, ds)
                End If
            Catch ex As Exception
                InformationMessageModule.InformationMessage("Errore nell'esportazione del file")
            End Try
        End If
        objSaveFileDialog.Dispose()
        objSaveFileDialog = Nothing
        GC.Collect()
    End Sub

    Public Shared Sub ExportXml(ByVal fileName As String, ByVal ds As DataSet)
        ds.WriteXml(fileName)
    End Sub

    Public Shared Sub ExportHtml(ByVal fileName As String, ByVal ds As DataSet)
        Dim fs As New System.IO.FileStream(fileName, IO.FileMode.OpenOrCreate, System.IO.FileAccess.Write)
        Dim bs As New System.IO.BufferedStream(fs)
        Dim sw As New System.IO.StreamWriter(bs)
        sw.WriteLine("<html>")
        sw.WriteLine("<head>")
        sw.WriteLine("<title>")
        sw.WriteLine(ds.DataSetName)
        sw.WriteLine("</title>")
        sw.WriteLine("</head>")
        sw.WriteLine("<body>")
        Dim i, r, c As Integer
        For i = 0 To ds.Tables.Count - 1
            sw.WriteLine("<table border=1>")
            sw.WriteLine("<tr>")
            For c = 0 To ds.Tables(i).Columns.Count - 1
                sw.Write("<td>{0}</td>", ds.Tables(i).Columns(c).ColumnName)
            Next
            sw.WriteLine("</tr>")
            For r = 0 To ds.Tables(i).Rows.Count - 1
                sw.WriteLine("<tr>")
                For c = 0 To ds.Tables(i).Columns.Count - 1
                    sw.Write("<td>{0}</td>", ds.Tables(i).Rows(r).Item(c))
                Next
                sw.WriteLine("</tr>")
            Next
            sw.WriteLine("</table>")
            sw.WriteLine("</hr>")
        Next
        sw.WriteLine("</body>")
        sw.WriteLine("</html>")
        sw.Close()
    End Sub

    Public Shared Sub SendEMail(ByVal ds As DataSet)
        Dim str As String
        str = InputBox("Inserire l'indirizzo e-Mail di Destinazione", "Richiesta e-Mail", "user@site.com")
        If str Is Nothing Or str = "" Then Return
        SendEMail("anonymous@anonymous.com", str, ds)
    End Sub

    Public Shared Sub SendEMail(ByVal FromAddress As String, ByVal ToAddress As String, ByVal ds As DataSet)
        Try
            Dim mail As New MailMessage()
            mail.From = FromAddress
            mail.To = ToAddress
            mail.Subject = "Report"
            mail.Body = "La tabella esportata  contenuta nell'Attachment"
            mail.BodyFormat = MailFormat.Text

            Dim fileName As String = System.IO.Path.GetTempPath() & "default.htm"

            ExportHtml(fileName, ds)

            Dim ma As New MailAttachment(fileName)
            mail.Attachments.Add(ma)
            SmtpMail.Send(mail)
            System.IO.File.Delete(fileName)
        Catch ex As Exception
            CustomControls.InformationMessage("Errore nell'invio della Mail")
        End Try
    End Sub
End Class
