Public Class PushPinControl
    Inherits System.Windows.Forms.UserControl

    Friend WithEvents objImageList As System.Windows.Forms.ImageList
    Private components As System.ComponentModel.IContainer
    Public Value As Boolean
    Private DataSource As CurrencyManager
    Private RowNum As Integer
    Private DGCol As DataGridPushPinColumn

    Friend Sub New(ByVal Value As Boolean, ByVal DGCol As DataGridPushPinColumn, ByVal DataSource As CurrencyManager, ByVal RowNum As Integer)
        InitializeComponent()
        Me.Value = Value
        Me.DataSource = DataSource
        Me.RowNum = RowNum
        Me.DGCol = DGCol
        If Me.Value = False Then
            Me.objToolTip.SetToolTip(Me, "Disabled")
        Else
            Me.objToolTip.SetToolTip(Me, "Enabled")
        End If
    End Sub

    Public Sub New()
        InitializeComponent()
        Me.Value = False
        Me.DataSource = Nothing
        Me.RowNum = Nothing
        Me.DGCol = Nothing
        If Me.Value = False Then
            Me.objToolTip.SetToolTip(Me, "Disabled")
        Else
            Me.objToolTip.SetToolTip(Me, "Enabled")
        End If
    End Sub

    Friend WithEvents objToolTip As System.Windows.Forms.ToolTip

    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(PushPinControl))
        Me.objImageList = New System.Windows.Forms.ImageList(Me.components)
        Me.objToolTip = New System.Windows.Forms.ToolTip(Me.components)
        '
        'objImageList
        '
        Me.objImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit
        Me.objImageList.ImageSize = New System.Drawing.Size(16, 16)
        Me.objImageList.ImageStream = CType(resources.GetObject("objImageList.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.objImageList.TransparentColor = System.Drawing.Color.Transparent
        '
        'PushPinControl
        '
        Me.Name = "PushPinControl"
        Me.objToolTip.SetToolTip(Me, "Disattivo")

    End Sub

    Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        Dim g As Graphics = e.Graphics
        Dim BackBrush As SolidBrush = New SolidBrush(Color.MidnightBlue)
        Dim ImagePic As Bitmap
        If Value = False Then
            ImagePic = CType(objImageList.Images(0), Bitmap)
        Else
            ImagePic = CType(objImageList.Images(1), Bitmap)
        End If
        g.FillRectangle(BackBrush, 0, 0, Bounds.Width, Bounds.Height)
        g.DrawImage(CType(ImagePic, Image), ((Bounds.Width - ImagePic.Width) \ 2), 0, ImagePic.Width, ImagePic.Height)
    End Sub

    Private Sub PushPinControl_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Leave
        Me.Visible = False
        If Not DGCol Is Nothing Then
            DGCol.CommitEdit(Me.DataSource, Me.RowNum, Me.Value)
        End If
    End Sub

    Private Sub PushPinControl_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Click
        Me.Value = Not Me.Value
        If Me.Value = False Then
            Me.objToolTip.SetToolTip(Me, "Disabled")
        Else
            Me.objToolTip.SetToolTip(Me, "Enabled")
        End If
        Try
            If Not DGCol Is Nothing Then
                DGCol.SetValue(Me.DataSource, Me.RowNum, Value)
            End If
        Catch
        End Try
        Me.Invalidate()
    End Sub

End Class