Option Strict On

Imports System.Runtime.Serialization
Imports System.IO
Imports System.Runtime.Serialization.Formatters.Soap

<Serializable()> _
Public Class FixedColumnDefinitionList
    Inherits CollectionBase
    Implements ISerializable

    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(ByVal SoapString As String)
        MyBase.New()
        Try
            Dim f As ArrayList
            Dim buf As String
            f = CType(ObjectDumper.ObjectToString.Deserialize(buf), ArrayList)
            Me.Clear()
            Dim item As FixedColumnDefinition
            For Each item In f
                Me.Add(item)
            Next
        Catch ex As Exception
        End Try
    End Sub

    Public Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
        MyBase.New()
        Dim f As ArrayList
        Dim buf As String
        buf = CType(info.GetValue("FixedValues", GetType(String)), String)
        f = CType(ObjectDumper.ObjectToString.Deserialize(buf), ArrayList)
        Me.Clear()
        Dim item As FixedColumnDefinition
        For Each item In f
            Me.Add(item)
        Next
        buf = Nothing
        f = Nothing
        GC.Collect()
    End Sub 'New

    'Serialization function.
    Public Overridable Sub GetObjectData(ByVal info As SerializationInfo, ByVal context As StreamingContext) Implements ISerializable.GetObjectData
        info.AddValue("FixedItems", ObjectDumper.ObjectToString.Serialize(Me.List))
        GC.Collect()
    End Sub 'GetObjectData

    Default Public Property Item(ByVal ItemNumber As Integer) As FixedColumnDefinition
        Get
            If ItemNumber < 0 Or ItemNumber >= list.Count Then Throw New IndexOutOfRangeException() 'Return Nothing
            Return CType(List(ItemNumber), FixedColumnDefinition)
        End Get
        Set(ByVal Value As FixedColumnDefinition)
            List(ItemNumber) = Value
        End Set
    End Property

    Public Sub Remove(ByVal index As Integer)
        ' Check to see if there is a widget at the supplied index.
        If index > Count - 1 Or index < 0 Then
            ' If no widget exists, a messagebox is shown and the operation is 
            ' cancelled.
            Throw New Exception("Index not valid!")
        Else
            ' Invokes the RemoveAt method of the List object.
            List.RemoveAt(index)
        End If
    End Sub

    Public Sub Add(ByVal Item As FixedColumnDefinition)
        ' Invokes Add method of the List object to add a widget.
        If Item Is Nothing Then
            Return
        End If
        List.Add(Item)
    End Sub

    Public Function GetLength(ByVal i As Integer) As Integer
        Return Count
    End Function
End Class

<Serializable()> _
Public Class ItemColumnDefinitionList
    Inherits CollectionBase
    Implements ISerializable

    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(ByVal SoapString As String)
        MyBase.New()
        Try
            Dim f As ArrayList
            Dim buf As String
            f = CType(Deserialize(buf), ArrayList)
            Me.Clear()
            Dim item As ItemColumnDefinition
            For Each item In f
                Me.Add(item)
            Next
        Catch ex As Exception
        End Try
    End Sub

    Public Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
        MyBase.New()
        Dim f As ArrayList
        Dim buf As String
        buf = CType(info.GetValue("ItemValues", GetType(String)), String)
        f = CType(Deserialize(buf), ArrayList)
        Me.Clear()
        Dim item As ItemColumnDefinition
        For Each item In f
            Me.Add(item)
        Next
    End Sub 'New

    'Serialization function.
    Public Overridable Sub GetObjectData(ByVal info As SerializationInfo, ByVal context As StreamingContext) Implements ISerializable.GetObjectData
        info.AddValue("ItemValues", Serialize())
    End Sub 'GetObjectData

    Public Function Serialize() As String
        ' Opens a file and serializes the object into it in binary format.
        Dim obj As Object = Me
        Dim i As Integer
        Dim l As Integer = 64 * 1024

        Dim buf(l) As Byte
        Dim stream As New MemoryStream(buf)

        Dim s As New Text.StringBuilder(l)
        Dim formatter As New SoapFormatter()

        formatter.Serialize(stream, Me.InnerList)
        stream.Close()
        For i = 0 To l - 1
            If buf(i) <> 0 Then
                s.Append(Chr(buf(i)))
            End If
        Next
        Dim ret As String = s.ToString()
        buf = Nothing
        s = Nothing
        GC.Collect()
        Return ret
    End Function

    Public Function Deserialize(ByRef s As String) As Object
        Dim l As Integer = 64 * 1024
        Dim i As Integer
        Dim buf(l) As Byte
        For i = 0 To s.Length - 1
            buf(i) = CByte(Asc(s.Chars(i)))
        Next
        buf(i) = 0
        Dim stream As New MemoryStream(buf)

        Dim formatter As New SoapFormatter()
        Dim obj As Object

        obj = formatter.Deserialize(stream)
        stream.Close()
        buf = Nothing
        s = Nothing
        GC.Collect()
        Return obj
    End Function

    Default Public Property Item(ByVal ItemNumber As Integer) As ItemColumnDefinition
        Get
            If ItemNumber < 0 Or ItemNumber >= list.Count Then Throw New IndexOutOfRangeException() 'Return Nothing
            Return CType(List(ItemNumber), ItemColumnDefinition)
        End Get
        Set(ByVal Value As ItemColumnDefinition)
            List(ItemNumber) = Value
        End Set
    End Property

    Public Sub Remove(ByVal index As Integer)
        ' Check to see if there is a widget at the supplied index.
        If index > Count - 1 Or index < 0 Then
            ' If no widget exists, a messagebox is shown and the operation is 
            ' cancelled.
            Throw New Exception("Index not valid!")
        Else
            ' Invokes the RemoveAt method of the List object.
            List.RemoveAt(index)
        End If
    End Sub

    Public Sub Add(ByVal Item As ItemColumnDefinition)
        ' Invokes Add method of the List object to add a widget.
        If Not Item Is Nothing Then
            List.Add(Item)
        End If
    End Sub

    Public Function GetLength(ByVal i As Integer) As Integer
        Return Count
    End Function
End Class