Public Class DragDropPars
    Public Row As Integer
    Public Col As Integer
End Class

Public Enum CellDragDropEffect As Integer
    Copy
    Move
    None
End Enum

Public Class CellDragDropEventArgs
    Inherits System.EventArgs
    Private privSource As GanttCell
    Private privDest As GanttCell
    Private privType As String
    Private privEffect As CellDragDropEffect

    Public ReadOnly Property Effect() As CellDragDropEffect
        Get
            Return privEffect
        End Get
    End Property

    Public ReadOnly Property CellType() As String
        Get
            Return privType
        End Get
    End Property

    Public Sub New(ByVal ef As CellDragDropEffect, ByVal ct As String)
        privSource = New GanttCell()
        privDest = New GanttCell()
        privEffect = ef
        privType = ct
    End Sub

    Public Property Source() As GanttCell
        Get
            Return privSource
        End Get
        Set(ByVal Value As GanttCell)
            privSource = Value
        End Set
    End Property
    Public Property Destination() As GanttCell
        Get
            Return privDest
        End Get
        Set(ByVal Value As GanttCell)
            privDest = Value
        End Set
    End Property
End Class
