Option Explicit On 
Option Strict On

Imports System
Imports System.ComponentModel
Imports System.Globalization

Public Class FixedColumnDefinitionConverter
    Inherits ComponentConverter

    Public Sub New()
        MyBase.New(GetType(FixedColumnDefinition))
    End Sub

    ' Overrides the CanConvertFrom method of TypeConverter.
    ' The ITypeDescriptorContext interface provides the context for the
    ' conversion. Typically this interface is used at design time to 
    ' provide information about the design-time container.
    Public Overloads Overrides Function CanConvertFrom(ByVal context As ITypeDescriptorContext, ByVal sourceType As Type) As Boolean
#If DebugTrace Then
        Dim dumper1 As New ObjectDumper.FileDumper("c:\log2.txt")
        dumper1.Dump("CanConvertFrom: " & sourceType.ToString())
#End If
        If TypeOf sourceType Is String Then Return True
        If TypeOf sourceType Is Byte() Then Return True
        If sourceType Is GetType(FixedColumnDefinition) Then Return True
        Return MyBase.CanConvertFrom(context, sourceType)
    End Function

    ' Overrides the ConvertFrom method of TypeConverter.
    Public Overloads Overrides Function ConvertFrom(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object) As Object
#If DebugTrace Then
        Dim dumper1 As New ObjectDumper.FileDumper("c:\log2.txt")
#End If
        If value Is Nothing Then
#If DebugTrace Then
            dumper1.Dump("ConvertFrom: Nothing")
#End If
            Return Nothing
        End If
#If DebugTrace Then
        dumper1.Dump("ConvertFrom: " & value.GetType().ToString())
#End If
       Try
            If TypeOf (value) Is String Then
#If DebugTrace Then
                dumper1.Dump(value.ToString())
#End If
                Dim buf As String = CStr(value)
                Dim obj As Object
                obj = ObjectDumper.ObjectToString.Deserialize(buf)
#If DebugTrace Then
                dumper1.Dump("ConvertFrom Deserialization Output Type: " & obj.GetType().ToString())
                dumper1.Dump("ConvertFrom Cast Type: GanttLib.FixedColumnDefinition")
                dumper1.Dump("Deserialized Object: " & ObjectDumper.Dumper.DumpObject(obj))
#End If
                obj = New FixedColumnDefinition(obj)
#If DebugTrace Then
                dumper1.Dump("Returned Object: " & ObjectDumper.Dumper.DumpObject(obj))
#End If
                Return CType(obj, FixedColumnDefinition)
            End If
            If TypeOf (value) Is Byte() Then
                Dim buf As Byte() = CType(value, Byte())
                Dim obj As Object
                obj = ObjectDumper.ObjectToString.DeserializeFromByteArray(buf)
#If DebugTrace Then
                dumper1.Dump("ConvertFrom Deserialization Output Type: " & obj.GetType().ToString())
                dumper1.Dump("ConvertFrom Cast Type: GanttLib.FixedColumnDefinition")
                dumper1.Dump("Deserialized Object: " & ObjectDumper.Dumper.DumpObject(obj))
#End If
                obj = New FixedColumnDefinition(obj)
#If DebugTrace Then
                dumper1.Dump("Returned Object: " & ObjectDumper.Dumper.DumpObject(obj))
#End If
                Return CType(obj, FixedColumnDefinition)
            End If
            If TypeOf (value) Is FixedColumnDefinition Then
                Return value
            End If
        Catch ex As Exception
#If DebugTrace Then
            dumper1.Dump("ConvertFrom (Exception): " & ex.ToString())
#End If
        End Try
        Return MyBase.ConvertFrom(context, culture, value)
    End Function

    ' Overrides the ConvertTo method of TypeConverter.
    Public Overloads Overrides Function ConvertTo(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object, ByVal destinationType As Type) As Object
        If value Is Nothing Then Return Nothing
#If DebugTrace Then
        Dim dumper1 As New ObjectDumper.FileDumper("c:\log2.txt")
        dumper1.Dump("ConvertTo: " & destinationType.ToString())
#End If
        Dim str As String
        Dim buf() As Byte
        If destinationType Is GetType(System.String) Then
            If value Is Nothing Then Return Nothing
            Try
                str = ObjectDumper.ObjectToString.Serialize(value, 2048)
            Catch ex As Exception
#If DebugTrace Then
                dumper1.Dump("ConvertTo (Exception): " & ex.ToString())
#End If
            End Try
            Return str
        End If
        If destinationType Is GetType(Byte()) Then
            If value Is Nothing Then Return Nothing
            Try
                buf = ObjectDumper.ObjectToString.SerializeToByteArray(value, 2048)
            Catch ex As Exception
#If DebugTrace Then
                dumper1.Dump("ConvertTo (Exception): " & ex.ToString())
#End If
            End Try
            Return buf
        End If
        Return MyBase.ConvertTo(context, culture, value, destinationType)
    End Function
End Class

Public Class ItemColumnDefinitionConverter
    Inherits ComponentConverter

    Public Sub New()
        MyBase.New(GetType(ItemColumnDefinition))
    End Sub

    ' Overrides the CanConvertFrom method of TypeConverter.
    ' The ITypeDescriptorContext interface provides the context for the
    ' conversion. Typically this interface is used at design time to 
    ' provide information about the design-time container.
    Public Overloads Overrides Function CanConvertFrom(ByVal context As ITypeDescriptorContext, ByVal sourceType As Type) As Boolean
#If DebugTrace Then
        Dim dumper1 As New ObjectDumper.FileDumper("c:\log.txt")
        dumper1.Dump("CanConvertFrom: " & sourceType.ToString())
#End If
        If TypeOf sourceType Is String Then Return True
        If TypeOf sourceType Is Byte() Then Return True
        If sourceType Is GetType(ItemColumnDefinition) Then Return True
        Return MyBase.CanConvertFrom(context, sourceType)
    End Function

    ' Overrides the ConvertFrom method of TypeConverter.
    Public Overloads Overrides Function ConvertFrom(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object) As Object
#If DebugTrace Then
        Dim dumper1 As New ObjectDumper.FileDumper("c:\log.txt")
#End If
        If value Is Nothing Then
#If DebugTrace Then
            dumper1.Dump("ConvertFrom: Nothing")
#End If
            Return Nothing
        End If
#If DebugTrace Then
        dumper1.Dump("ConvertFrom: " & value.GetType().ToString())
#End If
        Try
            If TypeOf value Is String Then
#If DebugTrace Then
                dumper1.Dump(value.ToString())
#End If
                Dim buf As String = CStr(value)
                Dim obj As Object
                obj = ObjectDumper.ObjectToString.Deserialize(buf)
#If DebugTrace Then
                dumper1.Dump("ConvertFrom Deserialization Output Type: " & obj.GetType().ToString())
                dumper1.Dump("ConvertFrom Cast Type: GanttLib.itemColumnDefinition")
                dumper1.Dump(ObjectDumper.Dumper.DumpObject(obj))
#End If
                Return CType(New ItemColumnDefinition(obj), ItemColumnDefinition)
            End If
            If TypeOf value Is Byte() Then
#If DebugTrace Then
                dumper1.Dump(value.ToString())
#End If
                Dim buf() As Byte = CType(value, Byte())
                Dim obj As Object
                obj = ObjectDumper.ObjectToString.DeserializeFromByteArray(buf)
#If DebugTrace Then
                dumper1.Dump("ConvertFrom Deserialization Output Type: " & obj.GetType().ToString())
                dumper1.Dump("ConvertFrom Cast Type: GanttLib.itemColumnDefinition")
                dumper1.Dump(ObjectDumper.Dumper.DumpObject(obj))
#End If
                Return CType(New ItemColumnDefinition(obj), ItemColumnDefinition)
            End If
        Catch ex As Exception
#If DebugTrace Then
            dumper1.Dump("ConvertFrom (Exception): " & ex.ToString())
#End If
        End Try
        Return MyBase.ConvertFrom(context, culture, value)
    End Function

    ' Overrides the ConvertTo method of TypeConverter.
    Public Overloads Overrides Function ConvertTo(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object, ByVal destinationType As Type) As Object
        If value Is Nothing Then Return Nothing
#If DebugTrace Then
        Dim dumper1 As New ObjectDumper.FileDumper("c:\log.txt")
        dumper1.Dump("ConvertTo: " & destinationType.ToString())
#End If
        Dim str As String
        Dim buf() As Byte
        If destinationType Is GetType(System.String) Then
            If value Is Nothing Then Return Nothing
            Try
                str = ObjectDumper.ObjectToString.Serialize(value, 2048)
            Catch ex As Exception
#If DebugTrace Then
                dumper1.Dump("ConvertTo (Exception): " & ex.ToString())
#End If
            End Try
            Return str
        End If
        If destinationType Is GetType(Byte()) Then
            If value Is Nothing Then Return Nothing
            Try
                buf = ObjectDumper.ObjectToString.SerializeToByteArray(value, 2048)
            Catch ex As Exception
#If DebugTrace Then
                dumper1.Dump("ConvertTo (Exception): " & ex.ToString())
#End If
            End Try
            Return buf
        End If
        Return MyBase.ConvertTo(context, culture, value, destinationType)
    End Function
End Class
