Imports System.Text
Imports System.Reflection

Public Class Dumper

    Public Shared Function DumpObject(ByVal obj As Object) As String
        Return DumpObject(obj, -1)
    End Function

    Public Shared Function DumpObject(ByVal obj As Object, ByVal MaxLevel As Integer) As String
        Dim sb As New StringBuilder(10000)
        If obj Is Nothing Then
            Return "Nothing"
        End If
        PrivDump(sb, obj, "", 0, MaxLevel)
        Return sb.ToString()
    End Function

    Private Shared Sub PrivDump(ByVal sb As StringBuilder, ByVal obj As Object, ByVal objName As String, ByVal level As Integer, ByVal MaxLevel As Integer)
        Dim InitialStr As String = Space(level)
        If obj Is Nothing Then
            Return
        End If
        'If obj Is Nothing Then Return
        Dim t As System.Type
        t = obj.GetType()
        If MaxLevel >= 0 And level >= MaxLevel Then Return
        sb.Append(InitialStr & objName & " AS " & t.FullName & " = " & obj.ToString() & vbCrLf)
        If obj.GetType.BaseType Is GetType(System.ValueType) Then Return
        DumpType(InitialStr, sb, obj, level, t, MaxLevel)
        Dim bt As System.Type
        bt = t.BaseType
        If Not bt Is Nothing Then
            While Not bt Is GetType(Object)
                Dim tt As String = bt.FullName
                sb.Append(InitialStr & "(" & tt & ")" & vbCrLf)
                DumpType(InitialStr, sb, obj, level, bt, MaxLevel)
                bt = bt.BaseType
                If bt Is Nothing Then Exit While
            End While
        End If
    End Sub

    Private Shared Sub DumpType(ByVal InitialStr As String, ByVal sb As StringBuilder, ByVal obj As Object, ByVal level As Integer, ByVal t As System.Type, ByVal maxlevel As Integer)
        Dim fi() As FieldInfo = t.GetFields(BindingFlags.Public Or BindingFlags.NonPublic Or BindingFlags.Instance)
        Dim f As FieldInfo
        If t Is GetType(System.Delegate) Then Return
        For Each f In fi
            PrivDump(sb, f.GetValue(obj), f.Name, level + 1, maxlevel)
        Next
        Dim arl() As Object
        Dim i As Integer
        If TypeOf obj Is System.Array Then
            Try
                arl = CType(obj, Object())
                For i = 0 To arl.GetLength(0) - 1
                    PrivDump(sb, arl(i), "[" & i & "]", level + 1, maxlevel)
                Next
            Catch ex As Exception
            End Try
        End If
    End Sub

    Public Shared Function GetFieldValue(ByVal obj As Object, ByVal fieldName As String) As Object
        Dim t As System.Type = obj.GetType()
        Dim f As FieldInfo = t.GetField(fieldName, BindingFlags.Public Or BindingFlags.NonPublic Or BindingFlags.Instance)
        If f Is Nothing Then
            Dim dumper1 As New ObjectDumper.FileDumper("c:\log2.txt")
            dumper1.Dump("GetFieldValue field not found: " & fieldName)
            Return Nothing
        End If
        Return f.GetValue(obj)
    End Function


End Class
