Imports System.IO
Imports System.Runtime.Serialization.Formatters.Soap

Public Class ObjectToString

    Public Shared Function Serialize(ByVal ObjToSerialize As Object) As String
        Serialize(ObjToSerialize, 64 * 1024)
    End Function

    Public Shared Function Serialize(ByVal ObjToSerialize As Object, ByVal BufSize As Integer) As String
        Dim i As Integer
        Dim l As Integer = BufSize

        Dim buf(l) As Byte
        Dim stream As New MemoryStream(buf)

        Dim s As New Text.StringBuilder(l)
        Dim formatter As New SoapFormatter()

        formatter.Serialize(stream, ObjToSerialize)
        stream.Close()
        For i = 0 To l - 1
            If buf(i) <> 0 Then
                s.Append(Chr(buf(i)))
            End If
        Next
        Dim ret As String = s.ToString()
        s = Nothing
        buf = Nothing
        GC.Collect()
        Return ret
    End Function

    Public Shared Function Deserialize(ByRef Source As String) As Object
        Dim i As Integer
        Dim buf(Source.Length) As Byte
        For i = 0 To Source.Length - 1
            buf(i) = CByte(Asc(Source.Chars(i)))
        Next
        buf(i) = 0
        Dim stream As New MemoryStream(buf)

        Dim formatter As New SoapFormatter()
        Dim o As Object = Nothing

        o = formatter.Deserialize(stream)
        stream.Close()
        buf = Nothing
        Source = Nothing
        GC.Collect()
        Return o
    End Function

    Public Shared Function SerializeToByteArray(ByVal ObjToSerialize As Object, ByVal BufSize As Integer) As Byte()
        Dim i As Integer
        Dim l As Integer = BufSize

        Dim buf(l) As Byte
        Dim stream As New MemoryStream(buf)

        Dim formatter As New SoapFormatter()

        formatter.Serialize(stream, ObjToSerialize)
        stream.Close()
        Return buf
    End Function

    Public Shared Function DeserializeFromByteArray(ByRef Source() As Byte) As Object
        Dim stream As New MemoryStream(Source)

        Dim formatter As New SoapFormatter()
        Dim o As Object = Nothing

        o = formatter.Deserialize(stream)
        stream.Close()
        Source = Nothing
        GC.Collect()
        Return o
    End Function

End Class
